package com.example.adventurepocket;

import android.graphics.drawable.AnimationDrawable;
import android.util.Log;

import java.util.Random;

class Creature extends GameEntity {
    public CreatureType GetType() {
        return cType;
    }
    AnimationDrawable walkAnimation;
    Item []inventory;
    private float eatAmt = 0.65f;
    enum CreatureType {
        Fire,
        Earth,
        Metal,
        Wood,
        Water
    }
    private CreatureType cType;
    SpecialAttacks special;
    TimeOfDay time;
    //Creating a Player, the name should be something the player can change, so its not set to anything yet, but shouldn't be hard to get them to be able to type a name in
    Creature() {
        name = new RandomNames().SetRandomName();
        stats = new StatSet();
        time = TimeOfDay.TimeofDay();
        time.TimeOfDaySetup(24);
        inventory = new Item[6];

        CreatureSetup();
        Log.i("Testing - Player", name + " :   " + "Attack : " + stats.GetAttack() + " Defense : " + stats.GetDefense() + " Health : " + stats.GetHealth());
    }

    // Creature Setup, this will build the Creature after the Stats are initially setup.
    private void CreatureSetup() {
        stats.GenPlayerStats();

        SetRandomType();



        name = new RandomNames().SetRandomName();
    }

    // for setting the random type
    private void SetRandomType() {
        Random rand = new Random();
        TimeOfDay.TimeofDay().SetTurnCount(8);
        int i = rand.nextInt(5) + 1;
        switch (i) {
            case 1:
                cType = CreatureType.Fire;
                FireBaseStats();
                special = new SpecialAttacks.ExecuteAttack();
                SetupSpecial(special);
                //petImg.setImageResource(R.drawable.blueguy1);
                break;
            case 2:
                cType = CreatureType.Metal;
                AirBaseStats();
                special = new SpecialAttacks.ExecuteAttack();
                SetupSpecial(special);
                //petImg.setImageResource(R.drawable.redguy1);
                break;
            case 3:
                cType = CreatureType.Earth;
                EarthBaseStats();
                special = new SpecialAttacks.BleedAttack();
                SetupSpecial(special);
                //petImg.setImageResource(R.drawable.greenguy1);
                break;
            case 4:
                cType = CreatureType.Water;
                WaterBaseStats();
                special = new SpecialAttacks.BleedAttack();
                SetupSpecial(special);
                //petImg.setImageResource(R.drawable.greenguy1);
                break;
            case 5:
                cType = CreatureType.Wood;
                WoodBaseStats();
                special = new SpecialAttacks.BleedAttack();
                SetupSpecial(special);
                //petImg.setImageResource(R.drawable.greenguy1);
                break;
        }
    }

    private void FireBaseStats() {
        stats.SetAttack(stats.GetAttack() + 3);
        stats.SetDefense(stats.GetDefense() + 1);
        stats.SetUpHealth(stats.GetHealth() + 1);
    }

    private void AirBaseStats() {
        stats.SetAttack(stats.GetAttack() + 1);
        stats.SetDefense(stats.GetDefense() + 2);
        stats.SetUpHealth(stats.GetHealth() + 2);
    }

    private void EarthBaseStats() {
        stats.SetAttack(stats.GetAttack() + 1);
        stats.SetDefense(stats.GetDefense() + 3);
        stats.SetUpHealth(stats.GetHealth() + 1);
    }
    private void WoodBaseStats() {
        stats.SetAttack(stats.GetAttack() + 2);
        stats.SetDefense(stats.GetDefense() + 2);
        stats.SetUpHealth(stats.GetHealth() + 1);
    }
    private void WaterBaseStats() {
        stats.SetAttack(stats.GetAttack() + 2);
        stats.SetDefense(stats.GetDefense() + 1);
        stats.SetUpHealth(stats.GetHealth() + 2);
    }

    private void SetupSpecial(SpecialAttacks _special) {
        special = _special;
        Log.i("Testing - Attacks", "Attack Name : " + special.name + " Cooldown : " + special.GetCoolDown() + " Bleed Damage : " + special.SpecialAttack());
    }
    void ResetCreature()
    {
        CreatureSetup();
    }

    void RestForNight()
    {
        if(time.GetTurnCount() >= 22)
        {
            time.SetTurnCount(8);
        }
        else {
            time.SetTurnCount(6);
        }
        time.daysPassed += 1;
        Log.i("Pools", " Day : " + time.daysPassed );
        Log.i("Pools", time.GetTurnCount() + "/" + time.MAX_TURNS_PER_DAY);
    }

    void TakeAction(int _cost)
    {
        time.AddTurnCount(_cost);
        time.CheckPassOut();
        Log.i("Pools", time.GetTurnCount() + "/" + time.MAX_TURNS_PER_DAY);
    }

    void CreatureEat()
    {
        float foodAmt = (int)stats.GetMaxHealth() * eatAmt;
        stats.HealDamage((int)foodAmt);
    }
    void SetEatAmt(int _amtPct)
    {
        eatAmt = _amtPct;
    }
}

