package com.example.adventurepocket;

import android.util.Log;

class Enemy  extends GameEntity{

    Item []dropsPool;
    // Create an Enemy with a Name and the type, the Type will get the stat block associated with that type
    // to assign to that enemy
    Enemy()
    {
        super();
        stats = new StatSet();
        name = new RandomNames().SetRandomEnemyName();
        dropsPool = new Item[6];

        for (Item i: dropsPool)
        {
            i = ItemPool.RandomItem();
        }
    }

    // Specific Enemy Stuff
    // To Make a new Enemy, make a New Class for the enemy, It builds off enemy, Needs a Name, an eType and a StatSet. -- I generally just copy paste Goblin and change from there.
    // I set it up this way so you don't need to do a new Enemy(Name, Type, Stats) and instead just say Goblin dude = new Goblin(); and it will make one.
    // you can do that though, Enemy dude = new Enemy()
    static class Goblin extends Enemy
    {
        private Enemy enemy;
        Goblin()
        {
            enemy = new Enemy();
            etype = eType.Weak;
            stats.GenWeakStats();
            Log.i("Spawning", "Goblin Created");
        }

        public Enemy getEnemy() {
            return enemy;
        }

        public void setEnemy(Enemy enemy) {
            this.enemy = enemy;
        }
    }

    static class GoblinRogue extends Enemy
    {
        private Enemy enemy;
        GoblinRogue()
        {
            enemy = new Enemy();
            etype = eType.Avg;
            stats.GenAvgStats();
            Log.i("Spawning", "GoblinRogue Created");
        }

        public Enemy getEnemy() {
            return enemy;
        }

        public void setEnemy(Enemy enemy) {
            this.enemy = enemy;
        }
    }
    static class GoblinRanger extends Enemy
    {
        private Enemy enemy;
        GoblinRanger()
        {
            enemy = new Enemy();
            etype = eType.Strong;
            stats.GenStrongStats();
            Log.i("Spawning", "GoblinRanger Created");
        }

        public Enemy getEnemy() {
            return enemy;
        }

        public void setEnemy(Enemy enemy) {
            this.enemy = enemy;
        }
    }
    static class GoblinFighter extends Enemy
    {
        private Enemy enemy;
        GoblinFighter()
        {
            enemy = new Enemy();
            etype = eType.MiniBoss;
            stats.GenMiniBossStats();
            Log.i("Spawning", "GoblinFighter Created");
        }

        public Enemy getEnemy() {
            return enemy;
        }

        public void setEnemy(Enemy enemy) {
            this.enemy = enemy;
        }
    }
    static class GoblinMage extends Enemy
    {
        private Enemy enemy;

        GoblinMage()
        {
            enemy = new Enemy();
            etype = eType.Boss;
            stats.GenBossStats();
            Log.i("Pools", "GoblinMage Created");
        }

        public Enemy getEnemy() {
            return enemy;
        }

        public void setEnemy(Enemy enemy) {
            this.enemy = enemy;
        }
    }
}
