package com.example.adventurepocket;

import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.SurfaceHolder;
import android.view.View;
import android.widget.ImageView;
import android.widget.TextView;

import org.w3c.dom.Entity;
import org.w3c.dom.Text;

public class FightActivity extends GameSetup implements View.OnTouchListener{

    FightThread fightThread;
    FightManager fightState;

    ImageView attack;
    ImageView defend;;
    ImageView special;
    ImageView run;

    TextView PlayerAttack;
    TextView PlayerDefence;
    TextView PlayerMaxHP;
    TextView PlayerCurrentHP;
    TextView PlayerSpecial;
    TextView EnemyAttack;
    TextView EnemyDefence;
    TextView EnemyMaxHP;
    TextView EnemyCurrentHP;
    TextView BattleInfo;
    TextView GoldAmount;
    TextView Time;
    static boolean buttonsOn;
    private float timer;

    int specialCounter;
    int EnemyDamage;
    int PlayerDamage;
    int text;
    static boolean EnemyDead ;
    static boolean PlayerDead;
    boolean isDefending;
    int bleedStack;

    Enemy tmpEnemy;
    Creature player;
    TimeOfDay time;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_fight);
        makeFullScreen();
        timer = 0;
        isDefending = false;
        PlayerDead = false;
        EnemyDead = false;
        specialCounter = 0;
        buttonsOn = false;
        bleedStack = 0;

        fightThread = new FightThread();
        fightState = new FightManager();
        fightState.activity = this;


        attack = (ImageView) findViewById(R.id.button_attack);
        attack.setOnTouchListener(this);

        defend = (ImageView) findViewById(R.id.button_defend);
        defend.setOnTouchListener(this);

        special = (ImageView) findViewById(R.id.button_special);
        special.setOnTouchListener(this);

        run = (ImageView) findViewById(R.id.button_run);
        run.setOnTouchListener(this);

        PlayerAttack = (TextView) findViewById(R.id.text_PlayerAttack);
        PlayerDefence = (TextView) findViewById(R.id.text_PlayerDefence);
        PlayerMaxHP = (TextView) findViewById(R.id.text_PlayerMaxHP);
        PlayerCurrentHP = (TextView) findViewById(R.id.text_PlayerCurrentHP);
        PlayerSpecial = (TextView) findViewById(R.id.text_Special);
        EnemyAttack = (TextView) findViewById(R.id.text_EnemyAttack);
        EnemyDefence = (TextView) findViewById(R.id.text_EnemyDefence);
        EnemyMaxHP = (TextView) findViewById(R.id.text_EnemyMaxHP);
        EnemyCurrentHP = (TextView) findViewById(R.id.text_EnemyCurrentHP);
        BattleInfo = (TextView) findViewById(R.id.text_battleInfo);
        GoldAmount = (TextView)findViewById(R.id.text_goldAmount);
        Time = (TextView)findViewById(R.id.textView_time);

        time = TimeOfDay.TimeofDay();
        player = mEntityManger.iCreatureManager.pet;
        Log.i("Testing - Creature", "Your pet is named " +  player.name );
        Log.i("Testing - Creature", "HP: " +  player.stats.GetCurrentHealth() + " Attack: " + player.stats.GetAttack() + " Defence: " + player.stats.GetDefense() + " Special Time: " + player.special.coolDown);

        fightThread.activateFightThread(fightState);

    }


    @Override
    public boolean onTouch(View v, MotionEvent event) {
        if (buttonsOn) {
            switch (event.getAction()) {
                case MotionEvent.ACTION_DOWN:
                    switch (v.getId()) {
                        case R.id.button_attack:
                            attack.setImageResource(R.drawable.attackdown);
                            return true;
                        case R.id.button_defend:
                            defend.setImageResource(R.drawable.defenddown);
                            return true;
                        case R.id.button_special:
                            if (specialCounter == player.special.coolDown){
                                special.setImageResource(R.drawable.specialdown);
                                return true;}
                            else{
                                EnableButtons();
                                return false;}
                        case R.id.button_run:
                            run.setImageResource(R.drawable.rundown);
                            return true;
                    }

                case MotionEvent.ACTION_UP:
                    DisableButtons();
                    switch (v.getId()) {
                        case R.id.button_attack:
                            fightState.changeState(EState.BasicAttack);
                            return true;
                        case R.id.button_defend:
                            fightState.changeState(EState.Defend);
                            return true;
                        case R.id.button_special:
                            if (specialCounter == player.special.coolDown){
                                fightState.changeState(EState.SpecialAttack);
                                return true;}
                            else{
                                EnableButtons();
                                return false;}
                        case R.id.button_run:
                            fightState.changeState(EState.Flee);
                            return true;
                    }
                default:
                    return false;
            }
        }
        else
            return false;
    }

    void DisableButtons()
    {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                buttonsOn = false;
                attack.setImageResource(R.drawable.attackoff);
                defend.setImageResource(R.drawable.defendoff);
                run.setImageResource(R.drawable.runoff);
                special.setImageResource(R.drawable.specialoff);
            }
        });
    }

    void EnableButtons()
    {
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                buttonsOn = true;
                attack.setImageResource(R.drawable.attackup);
                defend.setImageResource(R.drawable.defendup);
                run.setImageResource(R.drawable.runup);
                EnableSpecial();
            }
        });
    }

    void EnableSpecial()
    {
        if (specialCounter == player.special.coolDown)      // change for however many turns you want the charge to take
        {
            special.setImageResource(R.drawable.specialup);
        }
    }

    void AddSpecial(){
        if (specialCounter < player.special.coolDown){
            specialCounter ++;}
    }

    void SpecialEffect(){
        switch (player.special.name){
            case "Bleed":
                bleedStack++;
                break;
            case "Execute":
                EnemyDamage = 9999;
                break;
            case "Quick Attack":
                tmpEnemy.stats.SetCurrentHealth(tmpEnemy.stats.GetCurrentHealth()-(player.special.SpecialAttack() - tmpEnemy.stats.GetDefense()));
                tmpEnemy.stats.SetCurrentHealth(tmpEnemy.stats.GetCurrentHealth()-(player.special.SpecialAttack() - tmpEnemy.stats.GetDefense()));
        }
    }

    void SpecialDamage(){
            tmpEnemy.stats.SetCurrentHealth(tmpEnemy.stats.GetCurrentHealth()-(player.special.SpecialAttack()*bleedStack));
            if(tmpEnemy.stats.GetCurrentHealth() <= 0)
            {
                EnemyDead = true;//for bleed
                EnemyDeath();
            }
    }

    void SpecialOff(){
        bleedStack = 0;
    }

    void UpdateStats(){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                PlayerAttack.setText("" + player.stats.GetAttack());
                PlayerDefence.setText(" " + player.stats.GetDefense());
                PlayerMaxHP.setText(" " + player.stats.GetMaxHealth());
                PlayerCurrentHP.setText(" " + player.stats.GetCurrentHealth());
                PlayerSpecial.setText("Turns: " + (player.special.GetCoolDown()-specialCounter));
                EnemyAttack.setText(""+tmpEnemy.stats.GetAttack());
                EnemyDefence.setText(""+tmpEnemy.stats.GetDefense());
                EnemyMaxHP.setText(""+tmpEnemy.stats.GetMaxHealth());
                EnemyCurrentHP.setText(""+tmpEnemy.stats.GetCurrentHealth());
                GoldAmount.setText(" : "+mEntityManger.iCreatureManager.getGold());
                Time.setText("Time : "+mTimeOfDay.GetTurnCount());
            }
        });
    }

    void UpdateBattleInfo(){
        runOnUiThread(new Runnable() {
            @Override
            public void run() {
                switch (text){
                    case 1:
                        //encounter
                        BattleInfo.setText("You've encountered " +  tmpEnemy.name + "!");
                        break;
                    case 2:
                        //basic attack
                        BattleInfo.setText("You did " + EnemyDamage + " damage to " + tmpEnemy.name + "!");
                        break;
                    case 3:
                        //special
                        BattleInfo.setText("Your special did " + EnemyDamage + " damage to " + tmpEnemy.name + "!");
                        break;
                    case 4:
                        //defending
                        BattleInfo.setText("Your defence doubled to " + (player.stats.GetDefense()*2) + " temperarly.");
                        break;
                    case 5:
                        //flee
                        BattleInfo.setText("You left the dungeon and returned home.");
                        break;
                    case 6:
                        //enemy attack
                        BattleInfo.setText("You took " + PlayerDamage + " damage from " + tmpEnemy.name + "!");
                        break;
                    case 7:
                        //player death
                        BattleInfo.setText("You have died! GAME OVER!");
                        break;
                    case 8:
                        //enemy death
                        BattleInfo.setText("You have defeated " + tmpEnemy.name + "!");
                        break;
                }
            }
        });
    }

    void Encounter(){
        Log.i("info", "Encounter");



        tmpEnemy = mEntityManger.iEnemyManager.ePool.randomEnemyGamePool[EnemyManager.iEnemyManager().ePool.currentEnemyInLine];
        Log.i("info","Current Enemy: " + EnemyManager.iEnemyManager().ePool.currentEnemyInLine);
        Log.i("Testing - Encounter", "You've encountered " +  tmpEnemy.name );

        text = 1;
        UpdateBattleInfo();
        UpdateStats();

        timer = 0;
    }

    void EnemyIntent(){
        Log.i("info", "Enemy Intent");
        tmpEnemy = mEntityManger.iEnemyManager.ePool.randomEnemyGamePool[EnemyManager.iEnemyManager().ePool.currentEnemyInLine];
        Log.i("Testing - Encounter", "Attack : " + tmpEnemy.stats.GetAttack() + " Defense : " + tmpEnemy.stats.GetDefense() + " HP: " + tmpEnemy.stats.GetCurrentHealth());
        //Enemy.stats.GetAttack();
        EnableButtons();
        //gets and draws enemy attack
    }

    void Choice(){
        Log.i("info", "Choice");
        UpdateStats();
        CheckIfDead();
    }

    void BasicAttack(){
        Log.i("info", "Basic Attack");
        //play attack animation
        //do damage calculations

        tmpEnemy = mEntityManger.iEnemyManager.ePool.randomEnemyGamePool[EnemyManager.iEnemyManager().ePool.currentEnemyInLine];
        EnemyDamage = player.stats.GetAttack() - tmpEnemy.stats.GetDefense();
        SpecialDamage();
        if (EnemyDamage < 0){
            EnemyDamage = 0;}
        Log.i("Testing - Encounter", "You did " +  EnemyDamage + " damage!");
        tmpEnemy.stats.SetCurrentHealth(tmpEnemy.stats.GetCurrentHealth()-EnemyDamage);
        Log.i("Testing - Encounter", "Enemy Current HP: " +  tmpEnemy.stats.GetCurrentHealth());

        text = 2;
        UpdateBattleInfo();
        DisableButtons();
        AddSpecial();

        CheckIfDead();
    }

    void SpecialAttack(){
        Log.i("info", "Special Attack");
        //play special animation
        tmpEnemy = mEntityManger.iEnemyManager.ePool.randomEnemyGamePool[EnemyManager.iEnemyManager().ePool.currentEnemyInLine];
        EnemyDamage = player.special.SpecialAttack() - tmpEnemy.stats.GetDefense();
        SpecialEffect();
        SpecialDamage();
        if (EnemyDamage < 0){
            EnemyDamage = 0;}
        Log.i("Testing - Encounter", "You did " +  EnemyDamage + " damage!");
        tmpEnemy.stats.SetCurrentHealth(tmpEnemy.stats.GetCurrentHealth()-EnemyDamage);
        Log.i("Testing - Encounter", "Enemy Current HP: " +  tmpEnemy.stats.GetCurrentHealth());

        text = 3;
        UpdateBattleInfo();
        DisableButtons();
        specialCounter = 0;

        CheckIfDead();
    }

    void Defend(){
        Log.i("info", "Defend");
        //play defend animation
        //update stats
        isDefending = true;
        SpecialDamage();
        Log.i("Testing - Creature", "Your defend has become " + (player.stats.GetDefense()*2));
        text = 4;
        UpdateBattleInfo();
        DisableButtons();
        AddSpecial();

        CheckIfDead();
    }

    void Flee(){
        Log.i("info", "Flee");
        //play run animation
        //return to home screen
        //update stats
        //reset enemy stats
        text = 5;
        UpdateBattleInfo();
        ExitFight();
    }

    void EnemyAttack(){
        Log.i("info", "Enemy Attack");

        tmpEnemy = mEntityManger.iEnemyManager.ePool.randomEnemyGamePool[EnemyManager.iEnemyManager().ePool.currentEnemyInLine];
        if (isDefending == true) {
            PlayerDamage = tmpEnemy.stats.GetAttack() - (player.stats.GetDefense()*2);
        }
        else{
            PlayerDamage = tmpEnemy.stats.GetAttack() - player.stats.GetDefense();
        }

        if (PlayerDamage < 0){
            PlayerDamage = 0;}
        Log.i("Testing - Encounter", "You took " +  PlayerDamage + " damage!");
        player.stats.SetCurrentHealth(player.stats.GetCurrentHealth()-PlayerDamage);
        Log.i("Testing - Encounter", "Your Current HP: " +  player.stats.GetCurrentHealth());
        isDefending = false;

        UpdateStats();
        text = 6;
        UpdateBattleInfo();

        if (player.stats.GetCurrentHealth() <= 0){
            PlayerDead = true;}
        //play attack animation
        //do damage calculations
        //update stats
        //play death animation if dead
    }

    void PlayerDeath(){
        Log.i("info", "Player Death");
        text = 7;
        UpdateBattleInfo();
        //play death animation
        //game over pop up
        //clear game data
        FightThread.isGameRunning = false;
    }

    void EnemyDeath(){
        Log.i("info", "Enemy Death");
        EnemyDead = false;

        text = 8;
        UpdateBattleInfo();
        SpecialOff();
        mEntityManger.iCreatureManager.addGold(10);
        time.AddTurnCount(1);
        if(time.CheckPassOut())
        {
            ExitFight();
        }
        if(mEntityManger.iEnemyManager.ePool.endOfPool && mEntityManger.iEnemyManager.ePool.currentEnemyInLine >= 10)
        {
            mEntityManger.iEnemyManager.ePool.endOfPool = false;
            ExitFight();
        }

        //play death animation
        //go to rewards
    }

    void Reward(){
        Log.i("info", "Reward");
        //get rewards
        //reward pop up
        mEntityManger.iCreatureManager.addGold(10);
        EnemyManager.iEnemyManager().ePool.IncreaseEnemyInLine(); //encounter number ++
        //return to encounter
    }

    void ExitFight()
    {
        super.finish();
        FightThread.isGameRunning = false;
    }

    void CheckIfDead()
    {
        if (tmpEnemy.stats.GetCurrentHealth() <= 0){
            EnemyDead = true;}
    }
}










