package com.example.adventurepocket;

import android.content.Intent;
import android.util.Log;

enum EState {
    Encounter,
    EnemyIntent,
    Choice,
    BasicAttack,
    SpecialAttack,
    Defend,
    Flee,
    EnemyAttack,
    PlayerDeath,
    EnemyDeath,
    Reward
}

public class FightManager {
    EState currentState;
    FightActivity activity;

    private float resetDuration = 60;

    public FightManager() {
        currentState = EState.Encounter;
        activity.buttonsOn = false;
    }

    public void updateState(float deltaTime) {

        switch (currentState) {
            case Encounter:
                activity.Encounter();
                changeState(EState.EnemyIntent);
                break;
            case EnemyIntent:
                activity.EnemyIntent();
                changeState(EState.Choice);
                break;
            case Choice:
                activity.Choice();
                break;
            case BasicAttack:
                activity.BasicAttack();
                if (!FightActivity.EnemyDead){
                    changeState(EState.EnemyAttack);}
                else{
                    changeState(EState.EnemyDeath);}
                break;
            case SpecialAttack:
                activity.SpecialAttack();
                if (!FightActivity.EnemyDead){
                    changeState(EState.EnemyAttack);}
                else{
                    changeState(EState.EnemyDeath);}
                break;
            case Defend:
                activity.Defend();
                if (!FightActivity.EnemyDead) {
                    changeState(EState.EnemyAttack);
                }
                 else {
                    changeState(EState.EnemyDeath);
                }
                    break;
            case Flee:
                activity.Flee();
                break;
            case EnemyAttack:
                activity.EnemyAttack();
                if (!FightActivity.PlayerDead){
                    changeState(EState.EnemyIntent);}
                else{
                    changeState(EState.PlayerDeath);}
                break;
            case PlayerDeath:
                activity.PlayerDeath();
                break;
            case EnemyDeath:
                activity.EnemyDeath();
                changeState(EState.Reward);
                break;
            case Reward:
                activity.Reward();
                changeState(EState.Encounter);
                break;
        }
    }

    public void changeState(EState newState) {
        if (currentState != newState) {
            currentState = newState;
        }
    }


}