package com.example.adventurepocket;

import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.TextView;


public class ShopInventory {

    enum ItemTransferStates {
        HasEmptySpaceAndItemNameFound,
        HasEmptySpaceAndItemNameNotFound,
        ItemNameNotFoundOrNoEmptySpace
    }

    //////////////////////////////////////
    //declariables
    public Item []shopInventory = new Item[6];

    final int shopGoldReserve = 5000;

    CreatureManager creatureInfo = CreatureManager.iCreatureManager();


    //end of declariables
    //////////////////////////////////////

    ShopInventory() {
        Log.i("shop_info", "ShopInventory Started");
        SetupShopInventory();
    }

    void SetupShopInventory() {
        Log.i("shop_info", "ShopInventory setup");

        for (int i = 0; i < shopInventory.length; i++) {
            shopInventory[i] = ItemPool.RandomItem();
            Log.i("shop_info", "SetupShop, Item Added: " + shopInventory[i].GetName());
        }
    }

    Item FindItemByName(String itemName) {
        for (int i = 0; i < shopInventory.length; i++) {
            if (shopInventory[i].GetName().equals(shopInventory[i].GetName())) {
                return shopInventory[i];
            }
        }
        return null;
    }

    //purely for testing
    Item GetFirstItem() {
        for (int i = 0; i < shopInventory.length; i++) {
            if (i == 1) {
                return shopInventory[i];
            }
        }
        return null;
    }

    boolean AddItemToInventory(Item[] arrayTo, Item inQuestion) {
        for (int i = 0; i < arrayTo.length; i++) {
            if (arrayTo[i] == null) {
                for (int j = 0; j < shopInventory.length; j++) {
                    if (shopInventory[j].GetName().equals(inQuestion.GetName())){
                        arrayTo[i] = shopInventory[j];
                        Log.i("shop_info", shopInventory[j].GetName());
                        return true;
                    }
                    else {
                        Log.i("shop_info", "couldn't add item to inventory");
                        return false;
                    }
                }
            }
        }
        return false;
    }

    boolean GetItemForChecks(Item lookingFor, Item[] array) {
        for (int i = 0; i < array.length; i++)
            if (array[i].GetName().equals(lookingFor.GetName())) {
                return true;
            }
        return false;
    }

    int GetShopGold() {return shopGoldReserve;}

    void DisplayShopInfo() {
        //shop info shows player what items are available and what they do
    }

    void RefreshInventory() {
        //to be called when shop is created and when the day resets, adds items to shop supplies
    }
}

class ShopKeeper{
    //shop keeper will have a switch that will give a player an item based on their selection.
    //essentially this is a private middle man between checking if the player is able to afford an item and the inventory
    //giving them the item
    //as well shop keeper will calculate his offers to a player when they sell an item, then add the item to the shop
    //supplies
    private static ShopKeeper iShopKeeper;

    ShopInventory keeperInventory = new ShopInventory();

    static ShopKeeper iShopKeeper() {
        if (iShopKeeper == null) {
            iShopKeeper = new ShopKeeper();
        }
        return iShopKeeper;
    }

    int CheckPlayerGold() {
       return keeperInventory.creatureInfo.getGold();
    }

    //this is called when player wants to buy an item from the shop
    void TakePlayerGoldandGiveItem(Item inQuestion) {
        //check player gold, see if they can afford item by comparing their available gold to the items cost value integer
        //get item info
        //if they have enough gold for the item
        if (CheckPlayerGold() > inQuestion.GetCost()) {
            //add a copy of the item they want from shop inventory to their open space
            if (keeperInventory.AddItemToInventory(keeperInventory.creatureInfo.pet.inventory, inQuestion)) {
                //remove gold from their inventory
                keeperInventory.creatureInfo.setGold(keeperInventory.creatureInfo.getGold() - inQuestion.GetCost());
                Log.i("shop_info", inQuestion.GetName() + " purchased successfully");

                for (int i = 0; i < keeperInventory.creatureInfo.pet.inventory.length; i++) {
                    if (keeperInventory.creatureInfo.pet.inventory[i] != null) {
                        Log.i("shop_info", "Player Inventory: " + keeperInventory.creatureInfo.pet.inventory[i].GetName());
                    }
                }
            }
        }
        else {
            //else they dont have sufficient gold
            //no changes to any inventory
            //display a dialogue message stating they cannot afford the item
            Log.i("shop_info", inQuestion.GetName() + " was not purchased");
        }
    }
}

