package com.example.adventurepocket;

import android.app.Activity;
import android.util.Log;

enum EShopState {
    Buy,
    Sell,
    Upgrade
}

public class ShopManager {
    private EShopState currentState;
    ShopScreen activity;
    private float shopTimer;
    private float resetDuration = 60;

    public ShopManager() {
        currentState = EShopState.Buy;
        ShopScreen.buttonsOn = false;
        shopTimer = 0;
    }

    public void updateState(float deltaTime) {

        switch (currentState) {
            case Buy:
                //activate pop up, in the function that acitvates it, it will change the state
                activity.sell.setImageResource(R.drawable.sell);
                activity.upgrade.setImageResource(R.drawable.upgrades);

                ShopScreen.buttonsOn = true;

                break;
            case Sell:
                activity.sell.setImageResource(R.drawable.buy);
                //activate pop up, in the function that acitvates it, it will change the state

                ShopScreen.buttonsOn = true;
                break;
            case Upgrade:
                activity.upgrade.setImageResource(R.drawable.shop_button_pressed);
                //activate pop up, in the function that acitvates it, it will change the state

                ShopScreen.buttonsOn = true;
                break;
        }
        activity.SwitchInventoryUI(currentState);
    }

    public void changeState(EShopState newState) {
        if (currentState != newState) {
            currentState = newState;
        }
    }

    public EShopState GetState() {return currentState;}
}
