package com.example.adventurepocket;

abstract class SpecialAttacks
{

    String name;
    int coolDown;

    // Special Attacks are added to Weapons and Enemies, on a Weapon it gives the Pet a special attack, Enemies will each get their own special attack, bosses may get more.
    SpecialAttacks()
    {

    }
    int GetCoolDown()
    {
        return coolDown;
    }
    void SetCoolDown(int _value)
    {
        coolDown = _value;
    }
    abstract int SpecialAttack();

    static class BleedAttack extends SpecialAttacks
    {
        // Every turn the enemy will take this much damage
        int bleedDamage = 2;

         BleedAttack()
         {
             super();
             name = "Bleed";
             coolDown = 7;
         }

         @Override
         public int SpecialAttack()
         {
             return bleedDamage;
         }
    }

    static class ExecuteAttack extends SpecialAttacks
    {
        int damage = 9999;
        ExecuteAttack()
        {
            super();
            name = "Execute";
            coolDown = 10;
        }

        @Override
        public int SpecialAttack()
        {
            // Deal enough damage to kill the target.
            return damage;
        }
    }
    static class QuickAttack extends SpecialAttacks
    {
        // Skips the enemies attack turn, Possibly just setting the state back to player start of turn
        int attacks = 2;
        QuickAttack()
        {
            super();
            name = "Quick Attack";
            coolDown = 12;
        }

        @Override
        public int SpecialAttack()
        {
            return attacks;
        }
    }

}
