package com.example.adventurepocket;

import java.sql.Time;
import java.util.Random;
import java.util.jar.Attributes;

class StatSet
{

    private int baseAttack;
    private int baseDefense;
    private int baseHealth;

    private int currentHealth;
    private int maxHealth;
    private int poolsPassed = 0;
    private TimeOfDay timeOfDay = TimeOfDay.TimeofDay();
    StatSet() {


    }
    int GetPoolsPassed()
    {
        return poolsPassed;
    }
    void SetPoolsPassed(int _value)
    {
        poolsPassed = _value;
    }


    int GetHealth()
    {
        return baseHealth;
    }
    int GetAttack()
    {
        return baseAttack;
    }
    int GetDefense()
    {
        return baseDefense;
    }
    int GetMaxHealth()
    {
        return maxHealth;
    }
    int GetCurrentHealth()
    {
        return currentHealth;
    }

    void SetAttack(int _value)
    {
        baseAttack = _value;
    }
    void SetDefense(int _value)
    {
        baseDefense = _value;
    }
    void SetHealth(int _value){
        baseHealth = _value;
    }
    void SetUpHealth(int _value) {
        baseHealth = _value;
        currentHealth = _value;
        maxHealth = _value;
    }
    void SetCurrentHealth(int _value)
    {
        currentHealth = _value;
    }
    void SetMaxHealth(int _value)
    {
        maxHealth = _value;
    }

    void TakeDamage(int _value)
    {
        _value -= currentHealth;
    }
    void HealDamage(int _value)
    {
        currentHealth += _value;
        SetCurrentHealth(currentHealth);
        if(GetCurrentHealth() > GetMaxHealth())
        {
            SetCurrentHealth(GetMaxHealth());
        }
    }

    void IncreaseStat(int _value, int _atValue)
    {
        _value += _atValue;
    }
    void DecreaseStat(int _value, int _atValue)
    {
        _value -= _atValue;
    }
    void MultiplyStat(double _value, int _atValue)
    {
        _value *= _atValue;
    }


    private void EnemyStatSetup()
    {
        SetHealth(((baseHealth * (int)timeOfDay.daysPassed) / 3) + poolsPassed);
        SetAttack(((baseHealth * (int)timeOfDay.daysPassed) / 3) + poolsPassed);
        SetDefense(((baseHealth * (int)timeOfDay.daysPassed) / 3) + poolsPassed);
        if(GetAttack() <= 0)
        {
            SetAttack(1);
        }
        if(GetDefense() <= 0)
        {
            SetDefense(1);
        }
        currentHealth = baseHealth;
        maxHealth = baseHealth;
    }
    void GenWeakStats()
    {
        baseHealth = RandomMod(3, 2);
        baseAttack = RandomMod(2, 2);
        baseDefense = RandomMod(2, 2);
        EnemyStatSetup();
    }
    void GenAvgStats()
    {
        baseHealth = RandomMod(4, 3);
        baseAttack = RandomMod(2, 3);
        baseDefense = RandomMod(2, 3);
        EnemyStatSetup();
    }
    void GenStrongStats()
    {
        baseHealth = RandomMod(5, 4);
        baseAttack = RandomMod(3, 4);
        baseDefense = RandomMod(3, 4);
        EnemyStatSetup();
    }
    void GenMiniBossStats()
    {
        baseHealth = RandomMod(30, 8);
        baseAttack = RandomMod(5, 8);
        baseDefense = RandomMod(5, 8);
        EnemyStatSetup();
    }
    void GenBossStats()
    {

        baseHealth = RandomMod(50, 10);
        baseAttack = RandomMod(7, 10);
        baseDefense = RandomMod(7, 10);
        EnemyStatSetup();
    }
    void GenPlayerStats()
    {
        baseHealth = 1;
        baseAttack = 1;
        baseDefense = 1;
    }
    private int RandomMod(int _base, int _maxRange)
    {
        Random rand = new Random();
        int mod;
        mod = rand.nextInt(_maxRange);
        _base += mod;
        if(_base <= 0)
        {
            _base = 1;
        }
        return _base;
    }

}

