package com.example.adventurepocket;

import android.os.Bundle;
import android.util.Log;
import android.view.MotionEvent;
import android.view.View;
import android.widget.ImageView;

public class TrainScreen extends GameSetup implements View.OnTouchListener {

    ImageView Attack;
    ImageView Defense;
    ImageView Health;

    CreatureManager creatureInfo = CreatureManager.iCreatureManager();

    TrainThread trainThread;
    TrainManager trainState;

    int buffPriceLevel;
    int baseBuffValue;

    int buffPriceAttack;
    int buffPriceDefense;
    int buffPriceHealth;



    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);

        setContentView(R.layout.activity_train);
        makeFullScreen();

        Attack = (ImageView)findViewById(R.id.image_attack_train);
        Attack.setOnTouchListener(this);

        Defense = (ImageView)findViewById(R.id.image_defense_train);
        Defense.setOnTouchListener(this);

        Health = (ImageView)findViewById(R.id.image_health_train);
        Health.setOnTouchListener(this);

        trainThread = new TrainThread();
        trainState = new TrainManager();
        trainState.activity = this;
        trainThread.activateShopThread(trainState);

        buffPriceLevel = 1;
        baseBuffValue = 5;

        buffPriceAttack = 10 * buffPriceLevel;
        buffPriceDefense = 10 * buffPriceLevel;
        buffPriceHealth = 25 * buffPriceLevel;
    }

    @Override
    public boolean onTouch(View v, MotionEvent event) {
        if (event.getAction() == MotionEvent.ACTION_DOWN) {
            switch (v.getId()) {
                //this shit needs a function for the whole stat change process including the gold transaction form the player
                case R.id.image_attack_train:
                    if (ShopKeeper.iShopKeeper().CheckPlayerGold() > buffPriceAttack) {
                        creatureInfo.pet.stats.SetAttack(creatureInfo.pet.stats.GetAttack() + baseBuffValue);
                        creatureInfo.setGold(creatureInfo.getGold() - buffPriceAttack);
                        Attack.setImageResource(R.drawable.train_button_pressed);
                        String s1 = Integer.toString(creatureInfo.pet.stats.GetAttack());
                        Log.i("train_info", "New strength stat " + s1);
                        return true;
                    }
                    else {
                        Log.i("train_info", "No stat applied - src: Attack");
                        break;
                    }

                case R.id.image_defense_train:
                    if (ShopKeeper.iShopKeeper().CheckPlayerGold() > buffPriceDefense) {
                        creatureInfo.pet.stats.SetDefense(creatureInfo.pet.stats.GetDefense() + baseBuffValue);
                        creatureInfo.setGold(creatureInfo.getGold() - buffPriceDefense);
                        Defense.setImageResource(R.drawable.train_button_pressed);
                        String s2 = Integer.toString(creatureInfo.pet.stats.GetAttack());
                        Log.i("train_info", "New defense stat " + s2);
                        return true;
                    }
                    else {
                        Log.i("train_info", "No stat applied - src: Defense");
                        break;
                    }

                case R.id.image_health_train:
                    if (ShopKeeper.iShopKeeper().CheckPlayerGold() > buffPriceHealth) {
                        creatureInfo.pet.stats.SetMaxHealth(creatureInfo.pet.stats.GetMaxHealth() + baseBuffValue);
                        creatureInfo.setGold(creatureInfo.getGold() - buffPriceHealth);
                        Health.setImageResource(R.drawable.train_button_pressed);
                        String s3 = Integer.toString(creatureInfo.pet.stats.GetAttack());
                        Log.i("train_info", "New health stat " + s3);
                        return true;
                    }
                    else {
                        Log.i("train_info", "No stat applied - src: Health");
                        break;
                    }
            }
        }

        else if (event.getAction() == MotionEvent.ACTION_UP) {
            switch (v.getId()) {
                case R.id.image_attack_train:
                    Attack.setImageResource(R.drawable.attack);
                    return true;

                case R.id.image_defense_train:
                    Defense.setImageResource(R.drawable.defense);
                    return true;

                case R.id.image_health_train:
                    Health.setImageResource(R.drawable.health);
                    return true;
            }
        }
        return false;
    }
}
