package com.example.adventurepocket;

import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

import org.w3c.dom.Text;

public class gameScreen extends GameSetup implements View.OnClickListener, IActions
{
    Button fight;
    Button train;;
    Button shop;
    Button eat;
    Button rest;

    ImageView help;

    TextView health;
    TextView attack;
    TextView defense;
    TextView gold;
    TextView timer;
    TextView typeName;
    Popup popupTut1;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_game_screen);
        InitialSetup();
        makeFullScreen();
        PetUIUpdate();

    }

    @Override
    protected void onStart() {
        super.onStart();
        PetUIUpdate();
    }

    void InitialSetup()
    {
        // Text Setups
        health = (TextView)findViewById(R.id.text_health);
        attack = (TextView)findViewById(R.id.text_attack);
        defense = (TextView)findViewById(R.id.text_defense);
        gold = (TextView)findViewById(R.id.text_goldAmount);
        timer = (TextView)findViewById(R.id.textView_timer);
        typeName = (TextView)findViewById(R.id.text_typeandname);
        // Buttons
        fight = (Button)findViewById(R.id.button_fight);
        fight.setOnClickListener(this);
        train = (Button)findViewById(R.id.button_train);
        train.setOnClickListener(this);
        shop = (Button)findViewById(R.id.button_shop);
        shop.setOnClickListener(this);
        eat = (Button)findViewById(R.id.button_eat);
        eat.setOnClickListener(this);
        rest = (Button)findViewById(R.id.button_rest);
        rest.setOnClickListener(this);

        help = (ImageView)findViewById(R.id.imageView_help);
        help.setOnClickListener(this);

        popupTut1 = new Popup();

    }


    // Updates the Pet UI
    void PetUIUpdate()
    {

        int currentHealthText = mEntityManger.pet.stats.GetCurrentHealth();
        int maxHealthText = mEntityManger.pet.stats.GetMaxHealth();
        int playerAttack = mEntityManger.pet.stats.GetAttack();
        int playerDefense = mEntityManger.pet.stats.GetDefense();
        int playerGold = mEntityManger.iCreatureManager.getGold();
        String name = mEntityManger.pet.name;
        String type = mEntityManger.pet.GetType().toString();
        int TimeDay = mTimeOfDay.GetTurnCount();

        String HealthText = "Health : " + currentHealthText + "/" + maxHealthText;
        String AttackText = "Attack : " + playerAttack;
        String DefenseText = "Defense : " + playerDefense;
        String GoldText = "Gold : " + playerGold;
        String TimeText = "Time " + TimeDay + " : 00";
        String TypeNameText = "Name : " + name + " []  Type : " + type;

        health.setText(HealthText);
        attack.setText(AttackText);
        defense.setText(DefenseText);
        gold.setText(GoldText);
        timer.setText(TimeText);
        typeName.setText(TypeNameText);
    }

    @Override
    public void onClick(View v) {
        PetUIUpdate();
        if (v.getId() == fight.getId()) {
            // Fight Button
            ActFirst();
        }
        if (v.getId() == train.getId()) {
            // Train Button
            ActSecond();
        }
        if (v.getId() == shop.getId()) {
            // Shop Button
            ActShop();
        }
        if (v.getId() == eat.getId()) {
            // Eat Button
            mEntityManger.iCreatureManager.pet.TakeAction(1);
            ActThird();
        }
        if (v.getId() == rest.getId()) {
            // Sleep Button
            ActFourth();
        }
        if(v.getId() == help.getId())
        {
            ActHelp();
        }

    }

    @Override
    public void ActHelp()
    {
        popupTut1.PopUpCreate(1.0f,1.0f, R.layout.activity_tuts);
    }

    // Home Screen - Fight
    @Override
    public void ActFirst() {
        Intent i;
        i = new Intent(this, FightActivity.class);
        startActivity(i);
    }
    // Home Screen - Train
    @Override
    public void ActSecond() {
        Intent i;
        i = new Intent(this, TrainScreen.class);
        startActivity(i);
    }

    // Home Screen - Eat
    @Override
    public void ActThird() {
        mEntityManger.iCreatureManager.pet.CreatureEat();
        PetUIUpdate();
    }

    // Home Screen - Sleep
    @Override
    public void ActFourth() {
        mEntityManger.iCreatureManager.pet.RestForNight();
        PetUIUpdate();
    }

    // Home Screen - N/A
    @Override
    public void Back() {
        // No Back button for home Screen
    }

    // Home Screen - Options
    @Override
    public void Options() {
        // Open Options Menu
    }

    // Home Screen - Shop
    @Override
    public void ActShop(){
        Intent i;
        i = new Intent(this, ShopScreen.class);
        startActivity(i);
    }



}



